"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFileNamesFromGlobs = void 0;
var glob_1 = __importDefault(require("glob"));
function getFileNamesFromGlobs(globs) {
    var promises = globs.map(function (g) { return getFileNamesFromGlob(g); });
    return Promise.all(promises).then(function (values) { return values.reduce(function (a, b) { return a.concat(b); }, []); });
}
exports.getFileNamesFromGlobs = getFileNamesFromGlobs;
function getFileNamesFromGlob(globFileName) {
    return new Promise(function (resolve, reject) {
        glob_1.default(globFileName, function (err, files) {
            if (err) {
                reject(err);
                return;
            }
            resolve(files);
        });
    });
}
//# sourceMappingURL=getFileNamesFromGlobs.js.map